diff --git a/gcc/m2/gm2-compiler/SymbolTable.mod b/gcc/m2/gm2-compiler/SymbolTable.mod
index 8fed8b3fc5d..5ef71ea9bad 100644
--- a/gcc/m2/gm2-compiler/SymbolTable.mod
+++ b/gcc/m2/gm2-compiler/SymbolTable.mod
@@ -10647,16 +10653,16 @@ BEGIN
       ParamSym:    IF Param.name=NulName
                    THEN
                       Param.name := name ;
-                      Param.ShadowVar := MakeVariableForParam(tok, name, ProcSym,
-                                                              no, typetok)
+                      Param.ShadowVar := MakeVariableForParam(tok, name, ProcSym, kind,
+                                                              no, ParamType, typetok)
                    ELSE
                       InternalError ('name of parameter has already been assigned')
                    END |
       VarParamSym: IF VarParam.name=NulName
                    THEN
                       VarParam.name := name ;
-                      VarParam.ShadowVar := MakeVariableForParam(tok, name, ProcSym,
-                                                                 no, typetok)
+                      VarParam.ShadowVar := MakeVariableForParam(tok, name, ProcSym, kind,
+                                                                 no, ParamType, typetok)
                    ELSE
                       InternalError ('name of parameter has already been assigned')
                    END
@@ -10672,7 +10678,7 @@ END PutParamName ;
    AddParameter - adds a parameter ParSym to a procedure Sym.
 *)
 
-PROCEDURE AddParameter (Sym: CARDINAL; ParSym: CARDINAL) ;
+PROCEDURE AddParameter (Sym: CARDINAL; kind: ProcedureKind; ParSym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -10681,11 +10687,11 @@ BEGIN
       CASE SymbolType OF
 
       ErrorSym: |
-      ProcedureSym: PutItemIntoList(Procedure.ListOfParam, ParSym) |
-      ProcTypeSym : PutItemIntoList(ProcType.ListOfParam, ParSym)
+      ProcedureSym: PutItemIntoList (Procedure.Decl[kind].ListOfParam, ParSym) |
+      ProcTypeSym : PutItemIntoList (ProcType.ListOfParam, ParSym)
 
       ELSE
-         InternalError ('expecting a Procedure symbol')
+         InternalError ('expecting a Procedure or ProcType symbol')
       END
    END
 END AddParameter ;
@@ -10705,13 +10711,16 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: IF isVarParam
+      ProcedureSym: IF Procedure.BuildProcType
                     THEN
-                       PutProcTypeVarParam (Procedure.ProcedureType,
+                       IF isVarParam
+                       THEN
+                          PutProcTypeVarParam (Procedure.ProcedureType,
+                                               ParamType, isUnbounded)
+                       ELSE
+                          PutProcTypeParam (Procedure.ProcedureType,
                                             ParamType, isUnbounded)
-                    ELSE
-                       PutProcTypeParam (Procedure.ProcedureType,
-                                         ParamType, isUnbounded)
+                       END
                     END
 
       ELSE
@@ -10726,7 +10735,8 @@ END AddProcedureProcTypeParam ;
                 is a VAR parameter.
 *)
 
-PROCEDURE IsVarParam (Sym: CARDINAL; ParamNo: CARDINAL) : BOOLEAN ;
+PROCEDURE IsVarParam (Sym: CARDINAL; kind: ProcedureKind;
+                      ParamNo: CARDINAL) : BOOLEAN ;
 VAR
    pSym : PtrToSymbol ;
    IsVar: BOOLEAN ;
@@ -10737,7 +10747,8 @@ BEGIN
       CASE SymbolType OF
 
       ErrorSym    : |
-      ProcedureSym: IsVar := IsNthParamVar(Procedure.ListOfParam, ParamNo) |
+      ProcedureSym: IsVar := IsNthParamVar(Procedure.Decl[kind].ListOfParam,
+                                           ParamNo) |
       ProcTypeSym : IsVar := IsNthParamVar(ProcType.ListOfParam, ParamNo)
 
       ELSE
@@ -10748,6 +10759,38 @@ BEGIN
 END IsVarParam ;
 
 
+(*
+   IsVarParamAny - Returns a conditional depending whether parameter ParamNo
+                   is a VAR parameter.
+*)
+
+PROCEDURE IsVarParamAny (Sym: CARDINAL; ParamNo: CARDINAL) : BOOLEAN ;
+VAR
+   pSym: PtrToSymbol ;
+   kind: ProcedureKind ;
+BEGIN
+   pSym := GetPsym(Sym) ;
+   WITH pSym^ DO
+      CASE SymbolType OF
+
+      ErrorSym    : |
+      ProcedureSym: FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+                       IF GetProcedureDefined (Sym, kind)
+                       THEN
+                          RETURN IsNthParamVar (Procedure.Decl[kind].ListOfParam,
+                                                ParamNo)
+                       END
+                    END |
+      ProcTypeSym : RETURN IsNthParamVar(ProcType.ListOfParam, ParamNo)
+
+      ELSE
+         InternalError ('expecting a Procedure or ProcType symbol')
+      END
+   END ;
+   RETURN FALSE
+END IsVarParamAny ;
+
+
 (*
    IsNthParamVar - returns true if the n th parameter of the parameter list,
                    List, is a VAR parameter.
@@ -10783,18 +10826,18 @@ END IsNthParamVar ;
    NoOfParam - Returns the number of parameters that procedure Sym contains.
 *)
 
-PROCEDURE NoOfParam (Sym: CARDINAL) : CARDINAL ;
+PROCEDURE NoOfParam (Sym: CARDINAL; kind: ProcedureKind) : CARDINAL ;
 VAR
    pSym: PtrToSymbol ;
    n   : CARDINAL ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym    : n := 0 |
-      ProcedureSym: n := NoOfItemsInList(Procedure.ListOfParam) |
+      ProcedureSym: n := NoOfItemsInList(Procedure.Decl[kind].ListOfParam) |
       ProcTypeSym : n := NoOfItemsInList(ProcType.ListOfParam)
 
       ELSE
@@ -10805,6 +10848,37 @@ BEGIN
 END NoOfParam ;
 
 
+(*
+   NoOfParamAny - return the number of parameters for sym.
+*)
+
+PROCEDURE NoOfParamAny (sym: CARDINAL) : CARDINAL ;
+VAR
+   kind: ProcedureKind ;
+   pSym: PtrToSymbol ;
+BEGIN
+   AssertInRange (sym) ;
+   pSym := GetPsym (sym) ;
+   WITH pSym^ DO
+      CASE SymbolType OF
+
+      ErrorSym    : RETURN 0 |
+      ProcedureSym: FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+                        IF GetProcedureParametersDefined (sym, kind)
+                        THEN
+                           RETURN NoOfParam (sym, kind)
+                        END
+                    END |
+      ProcTypeSym : RETURN NoOfItemsInList(ProcType.ListOfParam)
+
+      ELSE
+         InternalError ('expecting a Procedure or ProcType symbol')
+      END
+   END ;
+   RETURN 0
+END NoOfParamAny ;
+
+
 (*
    HasVarParameters - returns TRUE if procedure, p, has any VAR parameters.
 *)
@@ -10813,10 +10887,10 @@ PROCEDURE HasVarParameters (p: CARDINAL) : BOOLEAN ;
 VAR
    i, n: CARDINAL ;
 BEGIN
-   n := NoOfParam(p) ;
+   n := NoOfParamAny (p) ;
    i := 1 ;
-   WHILE i<=n DO
-      IF IsVarParam(p, i)
+   WHILE i <= n DO
+      IF IsParameterVar (GetNthParamAny (p, i))
       THEN
          RETURN TRUE
       END ;
@@ -10838,13 +10912,14 @@ PROCEDURE PutUseVarArgs (Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym: |
-      ProcedureSym: Procedure.HasVarArgs := TRUE |
+      (* Currently can only declare var args in a definition module.  *)
+      ProcedureSym: Procedure.Decl[DefProcedure].HasVarArgs := TRUE |
       ProcTypeSym : ProcType.HasVarArgs := TRUE
 
       ELSE
@@ -10864,13 +10939,14 @@ PROCEDURE UsesVarArgs (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.HasVarArgs ) |
+      (* Currently can only declare var args in a definition module.  *)
+      ProcedureSym: RETURN( Procedure.Decl[DefProcedure].HasVarArgs ) |
       ProcTypeSym : RETURN( ProcType.HasVarArgs )
 
       ELSE
@@ -10885,17 +10961,17 @@ END UsesVarArgs ;
                   uses an optarg.
 *)
 
-PROCEDURE PutUseOptArg (Sym: CARDINAL) ;
+PROCEDURE PutUseOptArg (Sym: CARDINAL; kind: ProcedureKind) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym: |
-      ProcedureSym: Procedure.HasOptArg := TRUE |
+      ProcedureSym: Procedure.Decl[kind].HasOptArg := TRUE |
       ProcTypeSym : ProcType.HasOptArg := TRUE
 
       ELSE
@@ -10909,18 +10985,18 @@ END PutUseOptArg ;
    UsesOptArg - returns TRUE if procedure, Sym, uses varargs.
 *)
 
-PROCEDURE UsesOptArg (Sym: CARDINAL) : BOOLEAN ;
+PROCEDURE UsesOptArg (Sym: CARDINAL; kind: ProcedureKind) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.HasOptArg ) |
-      ProcTypeSym : RETURN( ProcType.HasOptArg )
+      ErrorSym    : RETURN FALSE |
+      ProcedureSym: RETURN Procedure.Decl[kind].HasOptArg |
+      ProcTypeSym : RETURN ProcType.HasOptArg
 
       ELSE
          InternalError ('expecting a Procedure or ProcType symbol')
@@ -10929,31 +11005,51 @@ BEGIN
 END UsesOptArg ;
 
 
+(*
+   UsesOptArgAny - returns TRUE if procedure Sym:kind uses an optional argument.
+*)
+
+PROCEDURE UsesOptArgAny (Sym: CARDINAL) : BOOLEAN ;
+VAR
+   pSym: PtrToSymbol ;
+BEGIN
+   pSym := GetPsym(Sym) ;
+   WITH pSym^ DO
+      CASE SymbolType OF
+
+      ErrorSym    : RETURN FALSE |
+      ProcedureSym: RETURN IsProcedureAnyDefaultBoolean (Sym, FALSE, UsesOptArg) |
+      ProcTypeSym : RETURN ProcType.HasOptArg
+
+      ELSE
+         InternalError ('expecting a Procedure or ProcType symbol')
+      END
+   END
+END UsesOptArgAny ;
+
+
 (*
    PutOptArgInit - makes symbol, Sym, the initializer value to
                    procedure, ProcSym.
 *)
 
-PROCEDURE PutOptArgInit (ProcSym, Sym: CARDINAL) ;
+PROCEDURE PutOptArgInit (ProcSym: CARDINAL; Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    IF NOT IsError(ProcSym)
    THEN
-      IF UsesOptArg(ProcSym)
-      THEN
-         pSym := GetPsym(ProcSym) ;
-         WITH pSym^ DO
-            CASE SymbolType OF
+      pSym := GetPsym(ProcSym) ;
+      WITH pSym^ DO
+         CASE SymbolType OF
 
-            ErrorSym    : |
-            ProcedureSym: Procedure.OptArgInit := Sym |
-            ProcTypeSym : ProcType.OptArgInit := Sym
+         ErrorSym    : |
+         ProcedureSym: Procedure.OptArgInit := Sym |
+         ProcTypeSym : ProcType.OptArgInit := Sym
 
-            ELSE
-               InternalError ('expecting a Procedure or ProcType symbol')
-            END
+         ELSE
+            InternalError ('expecting a Procedure or ProcType symbol')
          END
       END
    END
@@ -10971,19 +11067,16 @@ VAR
 BEGIN
    IF NOT IsError(ProcSym)
    THEN
-      IF UsesOptArg(ProcSym)
-      THEN
-         pSym := GetPsym(ProcSym) ;
-         WITH pSym^ DO
-            CASE SymbolType OF
+      pSym := GetPsym(ProcSym) ;
+      WITH pSym^ DO
+         CASE SymbolType OF
 
-            ErrorSym    : |
-            ProcedureSym: RETURN( Procedure.OptArgInit ) |
-            ProcTypeSym : RETURN( ProcType.OptArgInit )
+         ErrorSym    : |
+         ProcedureSym: RETURN( Procedure.OptArgInit ) |
+         ProcTypeSym : RETURN( ProcType.OptArgInit )
 
-            ELSE
-               InternalError ('expecting a Procedure or ProcType symbol')
-            END
+         ELSE
+            InternalError ('expecting a Procedure or ProcType symbol')
          END
       END
    END ;
@@ -11138,7 +11231,7 @@ BEGIN
       therefore we must subtract the Parameter Number from local variable
       total.
    *)
-   RETURN( n-NoOfParam(Sym) )
+   RETURN( n - NoOfParamAny (Sym) )
 END NoOfLocalVar ;
 
 
@@ -11193,16 +11286,35 @@ END IsParameterUnbounded ;
                       ParamNo is an unbounded array procedure parameter.
 *)
 
-PROCEDURE IsUnboundedParam (Sym: CARDINAL; ParamNo: CARDINAL) : BOOLEAN ;
+PROCEDURE IsUnboundedParam (Sym: CARDINAL; kind: ProcedureKind;
+                            ParamNo: CARDINAL) : BOOLEAN ;
 VAR
    param: CARDINAL ;
 BEGIN
-   Assert(IsProcedure(Sym) OR IsProcType(Sym)) ;
-   param := GetNthParam(Sym, ParamNo) ;
-   RETURN( IsParameterUnbounded(param) )
+   param := GetNthParam (Sym, kind, ParamNo) ;
+   RETURN IsParameterUnbounded (param)
 END IsUnboundedParam ;
 
 
+(*
+   IsUnboundedParam - Returns a conditional depending whether parameter
+                      ParamNo is an unbounded array procedure parameter.
+*)
+
+PROCEDURE IsUnboundedParamAny (Sym: CARDINAL; ParamNo: CARDINAL) : BOOLEAN ;
+VAR
+   kind: ProcedureKind ;
+BEGIN
+   FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+      IF GetProcedureParametersDefined (Sym, kind)
+      THEN
+         RETURN IsUnboundedParam (Sym, kind, ParamNo)
+      END
+   END ;
+   InternalError ('no procedure kind exists')
+END IsUnboundedParamAny ;
+
+
 (*
    IsParameter - returns true if Sym is a parameter symbol.
 *)
@@ -11256,255 +11368,157 @@ PROCEDURE IsProcedure (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=ProcedureSym )
 END IsProcedure ;
 
 
 (*
-   ProcedureParametersDefined - dictates to procedure symbol, Sym,
-                                that its parameters have been defined.
+   PutProcedureParametersDefined - the procedure symbol sym:kind
+                                   parameters have been defined.
 *)
 
-PROCEDURE ProcedureParametersDefined (Sym: CARDINAL) ;
+PROCEDURE PutProcedureParametersDefined (sym: CARDINAL; kind: ProcedureKind) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ErrorSym    : |
-      ProcedureSym: (* Assert(NOT Procedure.ParamDefined) ; *)
-                    Procedure.ParamDefined := TRUE
-
-      ELSE
-         InternalError ('expecting a Procedure symbol')
-      END
-   END
-END ProcedureParametersDefined ;
-
-
-(*
-   AreProcedureParametersDefined - returns true if the parameters to procedure
-                                   symbol, Sym, have been defined.
-*)
-
-PROCEDURE AreProcedureParametersDefined (Sym: CARDINAL) : BOOLEAN ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.ParamDefined )
-
-      ELSE
-         InternalError ('expecting a Procedure symbol')
-      END
-   END
-END AreProcedureParametersDefined ;
-
-
-(*
-   ParametersDefinedInDefinition - dictates to procedure symbol, Sym,
-                                   that its parameters have been defined in
-                                   a definition module.
-*)
-
-PROCEDURE ParametersDefinedInDefinition (Sym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
+   AssertInRange (sym) ;
+   pSym := GetPsym (sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym    : |
-      ProcedureSym: Assert(NOT Procedure.DefinedInDef) ;
-                    Procedure.DefinedInDef := TRUE
+      ProcedureSym: Procedure.Decl[kind].ParamDefined := TRUE ;
+                    Procedure.BuildProcType := FALSE |
+      ProcTypeSym :
 
       ELSE
          InternalError ('expecting a Procedure symbol')
       END
    END
-END ParametersDefinedInDefinition ;
+END PutProcedureParametersDefined ;
 
 
 (*
-   AreParametersDefinedInDefinition - returns true if procedure symbol, Sym,
-                                      has had its parameters been defined in
-                                      a definition module.
+   GetProcedureParametersDefined - returns true if procedure symbol sym:kind
+                                   parameters are defined.
 *)
 
-PROCEDURE AreParametersDefinedInDefinition (Sym: CARDINAL) : BOOLEAN ;
+PROCEDURE GetProcedureParametersDefined (sym: CARDINAL; kind: ProcedureKind) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
+   AssertInRange (sym) ;
+   pSym := GetPsym (sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.DefinedInDef )
+      ProcedureSym: RETURN( Procedure.Decl[kind].ParamDefined ) |
+      ProcTypeSym : RETURN( TRUE )
 
       ELSE
          InternalError ('expecting a Procedure symbol')
       END
    END
-END AreParametersDefinedInDefinition ;
+END GetProcedureParametersDefined ;
 
 
 (*
-   ParametersDefinedInImplementation - dictates to procedure symbol, Sym,
-                                       that its parameters have been defined in
-                                       a implemtation module.
+   PutProcedureDefined - the procedure symbol sym:kind is defined.
 *)
 
-PROCEDURE ParametersDefinedInImplementation (Sym: CARDINAL) ;
+PROCEDURE PutProcedureDefined (sym: CARDINAL; kind: ProcedureKind) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
+   AssertInRange (sym) ;
+   pSym := GetPsym (sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym    : |
-      ProcedureSym: Assert(NOT Procedure.DefinedInImp) ;
-                    Procedure.DefinedInImp := TRUE
+      ProcedureSym: Procedure.Decl[kind].Defined := TRUE
 
       ELSE
          InternalError ('expecting a Procedure symbol')
       END
    END
-END ParametersDefinedInImplementation ;
+END PutProcedureDefined ;
 
 
 (*
-   AreParametersDefinedInImplementation - returns true if procedure symbol, Sym,
-                                          has had its parameters been defined in
-                                          an implementation module.
+   GetProcedureDefined - returns true if procedure symbol sym:kind
+                         is defined.
 *)
 
-PROCEDURE AreParametersDefinedInImplementation (Sym: CARDINAL) : BOOLEAN ;
+PROCEDURE GetProcedureDefined (sym: CARDINAL; kind: ProcedureKind) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
-   pSym := GetPsym(Sym) ;
+   AssertInRange (sym) ;
+   pSym := GetPsym (sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
       ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.DefinedInImp )
-
-      ELSE
-         InternalError ('expecting a Procedure symbol')
-      END
-   END
-END AreParametersDefinedInImplementation ;
-
-
-(*
-   PutParametersDefinedByForward - records that the parameters have been
-                                   defined in a FORWARD declaration.
-*)
-
-PROCEDURE PutParametersDefinedByForward (ProcSym: CARDINAL) ;
-VAR
-   pSym: PtrToSymbol ;
-BEGIN
-   CheckLegal (ProcSym) ;
-   pSym := GetPsym (ProcSym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym: Procedure.DefinedByForward := TRUE
+      ProcedureSym: RETURN( Procedure.Decl[kind].Defined )
 
       ELSE
          InternalError ('expecting a Procedure symbol')
       END
    END
-END PutParametersDefinedByForward ;
+END GetProcedureDefined ;
 
 
 (*
-   GetParametersDefinedByForward - return TRUE if ProcSym has had its parameters
-                                   defined by a FORWARD declaration.
+   IsProcedureAnyBoolean - returns the boolean result from p
+                           for any of procedure kind which is defined.
 *)
 
-PROCEDURE GetParametersDefinedByForward (ProcSym: CARDINAL) : BOOLEAN ;
+PROCEDURE IsProcedureAnyBoolean (sym: CARDINAL; p: ProcAnyBoolean) : BOOLEAN ;
 VAR
-   pSym: PtrToSymbol ;
+   kind: ProcedureKind ;
 BEGIN
-   CheckLegal (ProcSym) ;
-   pSym := GetPsym (ProcSym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.DefinedByForward )
-
-      ELSE
-         InternalError ('expecting a Procedure symbol')
+   FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+      IF GetProcedureDefined (sym, kind)
+      THEN
+         RETURN p (sym, kind)
       END
-   END
-END GetParametersDefinedByForward ;
+   END ;
+   InternalError ('no procedure kind exists')
+END IsProcedureAnyBoolean ;
 
 
 (*
-   PutParametersDefinedByProper - records that the parameters have been
-                                   defined in a FORWARD declaration.
+   IsProcedureAnyDefaultBoolean - returns the boolean result from p
+                                  for any of procedure kind which is defined.
 *)
 
-PROCEDURE PutParametersDefinedByProper (ProcSym: CARDINAL) ;
+PROCEDURE IsProcedureAnyDefaultBoolean (sym: CARDINAL; default: BOOLEAN; p: ProcAnyBoolean) : BOOLEAN ;
 VAR
-   pSym: PtrToSymbol ;
+   kind: ProcedureKind ;
 BEGIN
-   CheckLegal (ProcSym) ;
-   pSym := GetPsym (ProcSym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ProcedureSym: Procedure.DefinedByProper := TRUE
-
-      ELSE
-         InternalError ('expecting a Procedure symbol')
+   FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+      IF GetProcedureDefined (sym, kind)
+      THEN
+         RETURN p (sym, kind)
       END
-   END
-END PutParametersDefinedByProper ;
+   END ;
+   RETURN default
+END IsProcedureAnyDefaultBoolean ;
 
 
 (*
-   GetParametersDefinedByProper - return TRUE if ProcSym has had its parameters
-                                   defined by a FORWARD declaration.
+   IsProcedureAnyNoReturn - return TRUE if any of the defined kinds
+                            of procedure sym is declared no return.
 *)
 
-PROCEDURE GetParametersDefinedByProper (ProcSym: CARDINAL) : BOOLEAN ;
-VAR
-   pSym: PtrToSymbol ;
+PROCEDURE IsProcedureAnyNoReturn (sym: CARDINAL) : BOOLEAN ;
 BEGIN
-   CheckLegal (ProcSym) ;
-   pSym := GetPsym (ProcSym) ;
-   WITH pSym^ DO
-      CASE SymbolType OF
-
-      ErrorSym    : RETURN( FALSE ) |
-      ProcedureSym: RETURN( Procedure.DefinedByProper )
-
-      ELSE
-         InternalError ('expecting a Procedure symbol')
-      END
-   END
-END GetParametersDefinedByProper ;
+   RETURN IsProcedureAnyDefaultBoolean (sym, FALSE, IsProcedureNoReturn)
+END IsProcedureAnyNoReturn ;
 
 
 (*
@@ -11607,7 +11621,7 @@ PROCEDURE IsPointer (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=PointerSym )
 END IsPointer ;
@@ -11621,7 +11635,7 @@ PROCEDURE IsRecord (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=RecordSym )
 END IsRecord ;
@@ -11635,7 +11649,7 @@ PROCEDURE IsArray (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=ArraySym )
 END IsArray ;
@@ -11649,7 +11663,7 @@ PROCEDURE IsEnumeration (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=EnumerationSym )
 END IsEnumeration ;
@@ -11663,7 +11677,7 @@ PROCEDURE IsUnbounded (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=UnboundedSym )
 END IsUnbounded ;
@@ -11890,7 +11904,7 @@ PROCEDURE IsSet (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=SetSym )
 END IsSet ;
@@ -11904,7 +11918,7 @@ PROCEDURE IsSetPacked (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal (Sym) ;
+   AssertInRange (Sym) ;
    pSym := GetPsym (Sym) ;
    RETURN (pSym^.SymbolType=SetSym) AND pSym^.Set.ispacked
 END IsSetPacked ;
@@ -11938,7 +11952,7 @@ PROCEDURE CheckUnbounded (Sym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
@@ -11967,7 +11981,7 @@ PROCEDURE IsOAFamily (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=OAFamilySym )
 END IsOAFamily ;
@@ -12563,15 +12577,15 @@ VAR
    i, n: CARDINAL ;
 BEGIN
    i := 1 ;
-   n := NoOfParam(sym) ;
-   WHILE i<=n DO
-      p := GetType(GetParam(sym, i)) ;
-      IF IsConst(p)
+   n := NoOfParamAny (sym) ;
+   WHILE i <= n DO
+      p := GetType (GetParam (sym, i)) ;
+      IF IsConst (p)
       THEN
-         MetaError3('the {%1N} formal parameter in procedure {%2Dad} should have a type rather than a constant {%3Dad}',
-                    i, sym, p)
+         MetaError3 ('the {%1N} formal parameter in procedure {%2Dad} should have a type rather than a constant {%3Dad}',
+                     i, sym, p)
       END ;
-      INC(i)
+      INC (i)
    END
 END SanityCheckParameters ;
 
@@ -12968,7 +12982,7 @@ END GetProcedureScope ;
 
 PROCEDURE IsModuleWithinProcedure (sym: CARDINAL) : BOOLEAN ;
 BEGIN
-   RETURN( GetProcedureScope(sym)#NulSym )
+   RETURN( GetProcedureScope (sym) # NulSym )
 END IsModuleWithinProcedure ;
 
 
@@ -13035,6 +13049,7 @@ BEGIN
                       ProcType.HasOptArg  := FALSE ;     (* Does this proc type use [ ] ? *)
                       ProcType.OptArgInit := NulSym ;    (* The optarg initial value.     *)
                       ProcType.ReturnOptional := FALSE ; (* Is the return value optional? *)
+                      ProcType.ReturnTypeTok := UnknownTokenNo ;
                       ProcType.Scope := GetCurrentScope() ;
                                                          (* scope of procedure.           *)
                       ProcType.Size := InitValue() ;
@@ -13075,7 +13090,7 @@ BEGIN
          InitWhereDeclared(At)
       END
    END ;
-   AddParameter(Sym, ParSym)
+   AddParameter (Sym, ProperProcedure, ParSym)
 END PutProcTypeParam ;
 
 
@@ -13102,7 +13117,7 @@ BEGIN
          InitWhereDeclared(At)
       END
    END ;
-   AddParameter(Sym, ParSym)
+   AddParameter (Sym, ProperProcedure, ParSym)
 END PutProcTypeVarParam ;
 
 
@@ -13982,84 +13997,85 @@ END PutDeclared ;
 
 
 (*
-   GetDeclaredDef - returns the tokenno where the symbol was declared.
-                    The priority of declaration is definition, implementation
-                    and program module.
+   GetDeclaredDef - returns the tokenno where the symbol was declared
+                    in the definition module.  UnknownTokenNo is returned
+                    if no declaration occurred.
 *)
 
 PROCEDURE GetDeclaredDef (Sym: CARDINAL) : CARDINAL ;
-VAR
-   declared: CARDINAL ;
 BEGIN
-   declared := GetDeclaredDefinition (Sym) ;
-   IF declared = UnknownTokenNo
-   THEN
-      RETURN GetDeclaredModule (Sym)
-   END ;
-   RETURN declared
+   RETURN GetDeclaredDefinition (Sym)
 END GetDeclaredDef ;
 
 
 (*
    GetDeclaredMod - returns the tokenno where the symbol was declared.
-                    The priority of declaration is program,
-                    implementation and definition module.
+                    in the program or implementation module.
+                    UnknownTokenNo is returned if no declaration occurred.
 *)
 
 PROCEDURE GetDeclaredMod (Sym: CARDINAL) : CARDINAL ;
-VAR
-   declared: CARDINAL ;
 BEGIN
-   declared := GetDeclaredModule (Sym) ;
-   IF declared = UnknownTokenNo
-   THEN
-      RETURN GetDeclaredDefinition (Sym)
-   END ;
-   RETURN declared
+   RETURN GetDeclaredModule (Sym)
 END GetDeclaredMod ;
 
 
 (*
-   GetDeclaredFor - returns the token where this symbol was declared.
-                    It chooses the first from the forward declaration,
-                    implementation module, program module
-                    and definition module.
+   GetDeclaredFor - returns the token where this forward procedure symbol
+                    was declared in the program or implementation module.
+                    UnknownTokenNo is returned if no declaration occurred.
 *)
 
 PROCEDURE GetDeclaredFor (Sym: CARDINAL) : CARDINAL ;
 BEGIN
-   RETURN GetProcedureDeclaredForward (Sym)
+   IF IsProcedure (Sym)
+   THEN
+      RETURN GetProcedureDeclaredTok (Sym, ForwardProcedure)
+   ELSE
+      RETURN UnknownTokenNo
+   END
 END GetDeclaredFor ;
 
 
 (*
-   GetProcedureDeclaredForward - return the token at which the forward
-                                 declaration procedure occurred.
+   GetProcedureKind - returns the procedure kind given the declaration tok.
+                      The declaration tok must match the ident tok in the
+                      procedure name.  It is only safe to call this
+                      procedure function during pass 2 onwards.
 *)
 
-PROCEDURE GetProcedureDeclaredForward (sym: CARDINAL) : CARDINAL ;
+PROCEDURE GetProcedureKind (sym: CARDINAL; tok: CARDINAL) : ProcedureKind ;
 VAR
+   kind: ProcedureKind ;
    pSym: PtrToSymbol ;
 BEGIN
    pSym := GetPsym (sym) ;
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: RETURN Procedure.Declared.Forward
+      ProcedureSym: FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+                       IF Procedure.Decl[kind].ProcedureTok = tok
+                       THEN
+                          RETURN kind
+                       END
+                    END |
+      ProcTypeSym:  RETURN ProperProcedure
 
       ELSE
-         InternalError ('expecting procedure symbol')
+         InternalError ('expecting ProcedureSym symbol')
       END
-   END
-END GetProcedureDeclaredForward ;
+   END ;
+   InternalError ('ProcedureSym kind has not yet been declared')
+END GetProcedureKind ;
 
 
 (*
-   PutProcedureDeclaredForward - places the tok to which the forward
-                                 declaration procedure occurred.
+   GetProcedureDeclaredTok - return the token where the
+                             declaration of procedure sym:kind
+                             occurred.
 *)
 
-PROCEDURE PutProcedureDeclaredForward (sym: CARDINAL; tok: CARDINAL) ;
+PROCEDURE GetProcedureDeclaredTok (sym: CARDINAL; kind: ProcedureKind) : CARDINAL ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -14067,21 +14083,23 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: Procedure.Declared.Forward := tok
+      ProcedureSym: RETURN Procedure.Decl[kind].ProcedureTok
 
       ELSE
          InternalError ('expecting procedure symbol')
       END
    END
-END PutProcedureDeclaredForward ;
+END GetProcedureDeclaredTok ;
 
 
 (*
-   GetProcedureDeclaredProper - return the token at which the forward
-                                declaration procedure occurred.
+   PutProcedureDeclaredTok - places the tok where the
+                             declaration of procedure sym:kind
+                             occurred.
 *)
 
-PROCEDURE GetProcedureDeclaredProper (sym: CARDINAL) : CARDINAL ;
+PROCEDURE PutProcedureDeclaredTok (sym: CARDINAL; kind: ProcedureKind;
+                                   tok: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
